## asis 2017

=== Makefile ===

include Makefile.stub

BLD=prod
COMPS=lib
GNSA=no
# lib/tools/toolsdev

# ==================================================== build

.PHONY: all
all: setup-snames
	$(GPRBUILD) -p -j0 -XBLD=$(BLD) -XOPSYS=$(OPSYS) -XGNSA=$(GNSA) \
		$(GPRBUILD_FLAGS) -XASIS_COMPONENTS=$(COMPS) build_asis.gpr

.PHONY: tools
tools: setup
	$(GPRBUILD) -p -j0 -XBLD=$(BLD) -XOPSYS=$(OPSYS) \
		$(GPRBUILD_FLAGS) -XASIS_COMPONENTS=tools build_asis.gpr

.PHONY: toolsdev
toolsdev: setup
	$(GPRBUILD) -p -j0 -XBLD=$(BLD) -XOPSYS=$(OPSYS) \
		$(GPRBUILD_FLAGS) -XASIS_COMPONENTS=toolsdev build_asis.gpr

# The setup target re-generates 4 generated Ada files. We avoid changing the
# timestamps of unchanged files, to avoid triggering recompilation of
# everything that depends on them. We first generate the files into (e.g.)
# snames.ns, and then if snames.ns and snames.ads differ, we do "mv snames.ns
# snames.ads". 'cmp' returns true (i.e. 0) if the files are identical.

.PHONY: setup
setup: setup-snames setup-factory

.PHONY: setup-snames
setup-snames: gnat/snames.ads-tmpl gnat/snames.adb-tmpl gnat/xutil.ads gnat/xutil.adb
	$(GPRBUILD) -p  -XBLD=$(BLD) $(GPRBUILD_FLAGS) gnat/snames.gpr
	cd gnat ; ./xsnamest$(exe_ext)
	if cmp --quiet gnat/snames.ns gnat/snames.ads; then \
	  echo "snames.ads unchanged"; \
	else \
	  echo "update snames.ads"; \
	  mv gnat/snames.ns gnat/snames.ads; \
	fi
	if cmp --quiet gnat/snames.nb gnat/snames.adb; then \
	  echo "snames.adb unchanged"; \
	else \
	  echo "update snames.adb"; \
	  mv gnat/snames.nb gnat/snames.adb; \
	fi

.PHONY: setup-factory
setup-factory:
	$(GPRBUILD) -p  -XBLD=$(BLD) $(GPRBUILD_FLAGS) \
		tools/tool_utils/generate_factory.gpr
	cd tools/tool_utils ; \
		./ada_trees-generate_factory$(exe_ext)
	if cmp --quiet tools/tool_utils/ada_trees-factory.ns tools/tool_utils/ada_trees-factory.ads; then \
	  echo "ada_trees-factory.ads unchanged"; \
	else \
	  echo "update ada_trees-factory.ads"; \
	  mv tools/tool_utils/ada_trees-factory.ns tools/tool_utils/ada_trees-factory.ads; \
	fi
	if cmp --quiet tools/tool_utils/ada_trees-factory.nb tools/tool_utils/ada_trees-factory.adb; then \
	  echo "ada_trees-factory.adb unchanged"; \
	else \
	  echo "update ada_trees-factory.adb"; \
	  mv tools/tool_utils/ada_trees-factory.nb tools/tool_utils/ada_trees-factory.adb; \
	fi

# ==================================================== install

.PHONY: install-clean
install-clean:
ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/asislib))
	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
		--project-subdir=lib/gnat asislib
endif
ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/build_asis))
	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
		--project-subdir=lib/gnat build_asis
endif

.PHONY: install
install: install-clean
	$(GPRINSTALL) -p -f --prefix=$(prefix) --sources-subdir=include/asis \
		--lib-subdir=lib/asis --project-subdir=lib/gnat -XBLD=$(BLD) \
		-XOPSYS=$(OPSYS) -XASIS_COMPONENTS=lib build_asis.gpr

.PHONY: install-tools-clean
install-tools-clean:
ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/asistools))
	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
		--project-subdir=lib/gnat asistools
endif

.PHONY: install-tools
install-tools: install-tools-clean
	$(GPRINSTALL) -p -f --prefix=$(prefix) --sources-subdir=include/asis \
		--lib-subdir=lib/asis --project-subdir=lib/gnat -XBLD=$(BLD) \
		--install-name=asistools \
		-XOPSYS=$(OPSYS) -XASIS_COMPONENTS=tools build_asis.gpr

# ==================================================== test

.PHONY: gnattest_hash_testing
gnattest_hash_testing:
	$(GPRBUILD) "-Pinternal/tools/gnattest/hash_testing/$@" "-XBLD=$(BLD)" "-XOPSYS=$(OPSYS)"

# ==================================================== clean

.PHONY: clean
clean:
	-$(GPRCLEAN) -XASIS_COMPONENTS=lib build_asis.gpr
	-$(GPRCLEAN) -XASIS_COMPONENTS=toolsdev build_asis.gpr
	-$(GPRCLEAN) tools/tool_utils/generate_factory.gpr
	rm -f tools/tool_utils/ada_trees-factory.ads tools/tool_utils/ada_trees-factory.adb

=== tools/gnat2xml/Makefile ===
# Make file for building gnat2xml and related tools, and for running tests.

# Targets:
#
#   'all' -- generate the schema. (Used to build all the programs, but that's
#    done elsewhere now.)
#
#   'test' -- run tests.
#
#   'update-schema' -- copy the newly generated schemas to the actual schemas.
#    This is for gnat2xml developers to use after making changes that cause
#    changes in the schema output by gnat2xsd (after checking that those
#    changes are correct).

include ../../Makefile.stub
BLD=prod

TIME=
#TIME=/usr/bin/time -f '%e seconds = %E'

GPRBUILD=$(TIME) gprbuild
GPRBUILD_FLAGS=-g -O0 -vm -gnatyN
GNAT2XML_FLAGS=-q

# ==================================================== build

default: all

all:
	$(GPRBUILD) -P gnat2xml.gpr -p -XBLD=$(BLD)

	@# Generate two XML Schemas, ada-schema.xsd.new is verbose,
	@# and ada-schema.compact.xsd.new is compact.
	./gnat2xsd > ada-schema.xsd.new
	./gnat2xsd --compact > ada-schema.compact.xsd.new

.PHONY: update-schema
update-schema:
	rm -f ada-schema.xsd.old
	mv ada-schema.xsd ada-schema.xsd.old
	mv ada-schema.xsd.new ada-schema.xsd
	rm -f ada-schema.compact.xsd.old
	mv ada-schema.compact.xsd ada-schema.compact.xsd.old
	mv ada-schema.compact.xsd.new ada-schema.compact.xsd

# ==================================================== clean

clean:
	rm -rf obj stage  ada-schema.*new

# ==================================================== test


# Test gnat2xsd by comparing its output against expected results.
# Test gnat2xml by validating its output against the schema using xmllint.
.PHONY: test-gnat2xml
test-gnat2xml: all
	@echo "Doing  test-gnat2xml"
	cd test ; rm -rf actual.compact actual.verbose ; mkdir -p actual.compact actual.verbose
	cd test ; ../gnat2xml --compact $(GNAT2XML_FLAGS) --output-dir=actual.compact -I../../../gnat -I../../../asis *.ad[sb]
	cd test ; ../gnat2xml    $(GNAT2XML_FLAGS) --output-dir=actual.verbose -I../../../gnat -I../../../asis *.ad[sb]

	@# We can''t validate against the compact schema, because we currently have
	@# interspersed Ada source in the XML output.
	@# cd test ; xmllint --schema ../ada-schema.compact.xsd.new actual.compact/*.xml --noout
	cd test ; xmllint --schema ../ada-schema.xsd.new actual.verbose/*.xml --noout

	@# Compare schemas to expected versions.
	diff    ada-schema.xsd ada-schema.xsd.new | head -80
	diff    ada-schema.compact.xsd ada-schema.compact.xsd.new | head -80
	diff -q ada-schema.xsd ada-schema.xsd.new
	diff -q ada-schema.compact.xsd ada-schema.compact.xsd.new

XML2GNAT_SRCS=*.ad[sb] mckae/*.ad[sb] ../tool_utils/*.ad[sb]

# Test gnat2xml by running the back-translator xml2gnat. If we translate some
# Ada program to XML and then back to Ada, that second Ada program should
# behave the same as the original (although the text of the two programs will
# typically differ in cosmetic ways). The "Ada program" we use for this test
# is gnat2xml itself. We also test for idempotency here: If we translate
# Ada-->XML--Ada-->XML-->Ada-->XML, the second and third stage versions of the
# XML should be identical.
.PHONY: test-xml2gnat
test-xml2gnat: all
	@echo "Doing  test-xml2gnat"
	rm -rf stage
	mkdir -p stage/1/compact-xml
	mkdir -p stage/1/xml stage/2/xml stage/3/xml
	cp -p boot_xml.gpr stage/1
	cp -p boot_xml.gpr stage/2
	cp -p boot_xml.gpr stage/3

	cp -p $(XML2GNAT_SRCS) stage/1
	rm -f stage/1/b__*
	chmod -w stage/1/*.ad[sb]
	printenv
	cd stage/1 ; $(TIME) ../../gnat2xml -P boot_xml.gpr --compact $(GNAT2XML_FLAGS) --output-dir=compact-xml *.ads *.adb

	cd stage/1 ; $(TIME) ../../gnat2xml -P boot_xml.gpr $(GNAT2XML_FLAGS) --output-dir=xml *.ads *.adb
	cd stage/1 ; xmllint --schema ../../ada-schema.xsd.new xml/*.xml --noout
	cd stage/1 ; $(TIME) ../../xml2gnat -v *.ads *.adb
	chmod -w stage/1/generated_ada/*

	cp -p boot.gpr stage/1/generated_ada
	cd stage/1/generated_ada ; $(GPRBUILD) -P boot.gpr -p -XBLD=debug $(GPRBUILD_FLAGS)
	cd stage/1/generated_ada ; ./gnat2xsd > ada-schema.xsd.new
	cd stage/1 ; ./generated_ada/gnat2xml -P boot_xml.gpr $(GNAT2XML_FLAGS) --output-dir=xmlxml *.ads *.adb

	cp -p stage/1/generated_ada/*.ad[sb] stage/2
	cd stage/2 ; $(TIME) ../../gnat2xml -P boot_xml.gpr $(GNAT2XML_FLAGS) --output-dir=xml *.ads *.adb
	cd stage/2 ; xmllint --schema ../../ada-schema.xsd.new xml/*.xml --noout
	cd stage/2 ; $(TIME) ../../xml2gnat *.ads *.adb
	chmod -w stage/2/generated_ada/*

	cp -p stage/2/generated_ada/*.ad[sb] stage/3
	cd stage/3 ; $(TIME) ../../gnat2xml -P boot_xml.gpr $(GNAT2XML_FLAGS) --output-dir=xml *.ads *.adb
	cd stage/3 ; $(TIME) ../../xml2gnat *.ads *.adb
	chmod -w stage/3/generated_ada/*

	@# Check that the translated version of gnat2xml behaves the same as the
	@# original:
	diff    stage/1/xml stage/1/xmlxml | head -80
	diff -q stage/1/xml stage/1/xmlxml
	@# Check that the translated version of gnat2xsd behaves the same as the
	@# original:
	diff    ada-schema.xsd.new stage/1/generated_ada/ada-schema.xsd.new | head -80
	diff -q ada-schema.xsd.new stage/1/generated_ada/ada-schema.xsd.new

	@# Check for idempotency:
	cd stage/1 ; 'ls' -1A *.ad[sb] > ada-files.list
	cd stage/1/generated_ada ; cat `cat ../ada-files.list` > ../generated_ada.ada
	cd stage/2 ; 'ls' -1A *.ad[sb] > ada-files.list
	cd stage/2/generated_ada ; cat `cat ../ada-files.list` > ../generated_ada.ada
	diff    stage/1/generated_ada.ada stage/2/generated_ada.ada | head -80
	diff -q stage/1/generated_ada.ada stage/2/generated_ada.ada
	diff    stage/2/xml stage/3/xml | head -80
	diff -q stage/2/xml stage/3/xml

.PHONY: test-gnat2tokens
test-gnat2tokens: all test-xml2gnat
	@echo "Doing  test-gnat2tokens"
	rm -rf stage/tokens ; mkdir -p stage/tokens
	$(TIME) ./gnat2xml-gnat2tokens stage/1/*.ad[sb] > stage/tokens/tokens.out
	@echo This generates a bunch of "line too long" warnings:
	gnatchop -w stage/tokens/tokens.out stage/tokens
	cp -p tokens.gpr stage/tokens
	cd stage/tokens ; $(GPRBUILD) -P tokens.gpr -p -XBLD=debug $(GPRBUILD_FLAGS)
	cd stage/tokens ; ./gnat2xsd > ../ada-schema.xsd.new

	@# Check that the translated version of gnat2xsd behaves the same as the
	@# original:
	diff    ada-schema.xsd.new stage/ada-schema.xsd.new | head -80
	diff -q ada-schema.xsd.new stage/ada-schema.xsd.new

XML2GNAT_SRC_LIST := $(notdir $(wildcard $(XML2GNAT_SRCS)))

# Test the output of tree-printing procedures (Put_Ada_Tree and
# Put_Regen_Ada in Ada_Trees.Self_Rep) by running the
# regenerate_ada programs produced by xml2gnat:
DO_REGEN_ADA_LIST := $(addprefix do-regen-ada-,$(XML2GNAT_SRC_LIST))
.PHONY: $(DO_REGEN_ADA_LIST)
$(DO_REGEN_ADA_LIST): do-regen-ada-% : all test-xml2gnat
	$(TIME) ./do-regen-ada.sh $*

# Test the output of tree-printing procedures (Put_Ada_Tree and
# Put_Self_Rep in Ada_Trees.Self_Rep) by running the
# self-replicating programs produced by xml2gnat:
DO_SELF_REP_LIST := $(addprefix do-self-rep-,$(XML2GNAT_SRC_LIST))
.PHONY: $(DO_SELF_REP_LIST)
$(DO_SELF_REP_LIST): do-self-rep-% : all test-xml2gnat
	$(TIME) ./do-self-rep.sh $*

.PHONY: test-buffers
test-buffers: all
	@echo "Doing  test-buffers"
	./pp-buffers-test

# Generate debugging output
.PHONY: debug
debug:
	rm -rf generated_ada
	./gnat2xml basic_decl.ads --output-dir=xml
	#???./xml2gnat --debug basic_decl.ads
	#--debug switch causes a crash due to "--&pp off" changes.

.PHONY: test
test: all test-xml2gnat test-buffers do-self-rep-basic_decl.ads do-regen-ada-basic_decl.ads test-gnat2tokens test-gnat2xml debug

################

# Target for debugging this Makefile

.PHONY: debug-makefile
debug-makefile:
	@echo "debug-makefile"
	@echo "  XML2GNAT_SRCS = $(XML2GNAT_SRCS)"
	@echo "  XML2GNAT_SRC_LIST = $(XML2GNAT_SRC_LIST)"
	@echo "  DO_SELF_REP_LIST = $(DO_SELF_REP_LIST)"
	@echo "  LARGE_SRCS = $(LARGE_SRCS)"
	@echo "  FAST_DO_SELF_REP_LIST = $(FAST_DO_SELF_REP_LIST)"
	@echo "  DO_REGEN_ADA_LIST = $(DO_REGEN_ADA_LIST)"
	@echo "debug-makefile done"

################################################################

# Reminder of arcane 'make' conventions:

# In the commands of static pattern rules:
# $@ -- target
# $< -- first prerequisite
# $^ -- all prerequisites
# $* -- stem (the part that matched %)

=== debian/changelog ===
asis (2017-2) unstable; urgency=medium

  * Rebuild with xmlada 17.1.2017-5 and gnatcoll 17.0.2017-3.
    -dev version is already new in testing.
  * Increase gprbuild verbosity in run-time test.
  * Standards-Version: 4.1.0.
  * Vcs-Mtn: new monotone URI format.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Sep 2017 19:27:08 +0200

asis (2017-1) unstable; urgency=medium

  * New upstream release.
    Runtime and -dev package renaming per Ada policy.
    Repackage without schemas and generate them during the build.
    Generate the ada_trees-factory sources for gnatpp gnat2xml.
  * Build with gnat-7, which handles SOURCE_DATE_EPOCH by itself.
    gcc-7.diff: adapt asis/2017 to gcc-7 instead of latest gcc.
  * Build all tools. Closes: #857135.
  * Link build helpers statically.
  * gnatgcc.patch: use libgnatvsn version instead of gnatgcc symlink.
  * Permute two patches in order to reflect a dependency.
  * Debhelper 10.
  * Standards-Version 4.0.1. HTTPS copyright format URL. Priority: optional.
  * Allow -doc package to satisfy Multi-Arch: foreign dependencies.
  * Enable all hardening flags. Parse the control file only once.
  * Watch file version 4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 11 Aug 2017 19:29:41 +0200

=== debian/control ===
Source: asis
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Section: libdevel
Priority: optional
Standards-Version: 4.1.0
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
 gnat, gnat-7,
# This line is parsed by debian/rules.
 libgnatvsn7-dev (>= 7.1.0-10),
# gnatvsn providing rident.ads.
# gprbuild cleaning auto.cgpr
 gprbuild (>= 2017),
# Some tools require gnatcoll.
 libgnatcoll16.1.0-dev (>= 17.0.2017-3),
 libxmlada-input7-dev (>= 17.1.2017-5),
 libxmlada-sax7-dev (>= 17.1.2017-5),
 libxmlada-dom7-dev (>= 17.1.2017-5),
# dh-ada-library knowing the new /usr/share/gpr path to projects.
 dh-ada-library (>= 6.11)
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
Vcs-Mtn: mtn://www.ada-france.org?org.debian.asis
Homepage: http://libre.adacore.com/libre/tools

Package: libasis2017-dev
Architecture: any
Depends: ${ada:Depends}, ${misc:Depends}
Suggests: asis-doc
Description: Ada Semantic Interface Specification (ASIS) headers and libraries
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package lets you build ASIS applications with GNAT.

Package: asis-programs
Architecture: any
Section: devel
Depends: gnat, gnat-7, ${shlibs:Depends}, ${misc:Depends}
Recommends: libaunit17.2017-dev
Description: Ada Semantic Interface Specification (ASIS) example programs
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
  * asistant is an interactive command-line tool to explore the ASIS parse tree
    of a program.
  * gnatcheck verifies the conformance of source text to coding conventions
  * gnatelim finds out unused subprograms and eliminates them.
  * gnatmetric calculates metrics such as code complexity.
  * gnatpp is a pretty-printer which reformats Ada source text according to
    a default or user-specified style guide.
  * gnatstub generates an empty but compilable body for a given specification.
  * gnattest creates AUnit test skeletons and harness for a project
    (gnattest requires the libaunit development package to be installed)

Package: libasis2017
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-7, ${shlibs:Depends}, ${misc:Depends}
Description: Ada Semantic Interface Specification (ASIS) runtime library
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the libraries necessary to execute ASIS programs.

Package: asis-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: gnat
Description: Ada Semantic Interface Specification (ASIS) documentation
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the tutorial, news and examples, but not the
 manuals because of their license. They are available online at
 http://www.adacore.com/asis.

=== debian/rules ===
#! /usr/bin/make -rf
# Debian build script for asis
# Copyright (c) 2003-2014 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under terms of the GNU General Public License as published
# by the Free Software Foundation; either version 3, or (at your
# option) any later version. This build script is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY; without even
# the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details. You
# should have received a copy of the GNU General Public License
# distributed with this build script; see file
# /usr/share/common-licenses/GPL. If not, see <http://www.gnu.org/licenses/>.

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: lib[a-z-]\+\([0-9.]\+\)$$/ \
    soversion:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

ADAFLAGS += -gnatfno -gnatwa -gnatVa

BUILDER_OPTIONS := $(subst -j,-XPROCESSORS=,$(BUILDER_OPTIONS))

######################################################################
%:
	dh $@ --with ada-library

# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build-arch build-indep test install clean)

######################################################################
# Build dynamic and static versions of the library.
# Import the dynamic version of the library and build each tool.
# Upstream Makefile does not allow to select tool, skip a static assistant,
# or select gnat2xml mains.
ALL_TOOLS := \
  asistant gnat2xml gnatcheck gnatelim gnatmetric gnatpp gnatstub gnattest
# Only this selection will be built and installed.
TOOLS := $(ALL_TOOLS)

# Building a tool will force the build of the shared libasis.
# build-factory will force the build of the static libasis.
# The aggregate project increases performance, as gprbuild only parses
# all projects once.
override_dh_auto_build-arch: dynamic_aggregate.gpr build-factory
	gprbuild $< -p $(BUILDER_OPTIONS) \
	  $(foreach v,ADAFLAGS LDFLAGS soversion,"-X$(v)=$($(v))")
override_dh_auto_clean:: dynamic_aggregate.gpr
	gprclean $< -Xsoversion=$(soversion)
	rm -f $<
dynamic_aggregate.gpr:
	echo 'aggregate project dynamic_aggregate is for project_files use ($(foreach t,$(TOOLS),"tools/$(t)/$(t).gpr",) "asis.gpr");end dynamic_aggregate;' > $@

######################################################################
# The factory generated sources are required for both -arch (for
# gnat2xml gnatpp) and -indep (for the schemas via gnat2xsd).
# The static ASIS library is built here as a dependency.
factory_dir := tools/tool_utils
factory_gpr := $(factory_dir)/generate_factory.gpr
factory_exe := $(factory_dir)/ada_trees-generate_factory
factory_out := ada_trees-factory

.PHONY: build-factory
build-factory:
	gprbuild $(factory_gpr) -p $(BUILDER_OPTIONS) \
	  $(foreach v,ADAFLAGS LDFLAGS,"-X$(v)=$($(v))")
	$(factory_exe)
	mv -f $(factory_out).nb $(factory_dir)/$(factory_out).adb
	mv -f $(factory_out).ns $(factory_dir)/$(factory_out).ads
override_dh_auto_clean::
	gprclean asis.gpr
	gprclean $(factory_gpr)
	rm -f $(factory_dir)/$(factory_out).ad[bs] $(factory_out).n[bs]

######################################################################
xsd_dir  := tools/gnat2xml
xsd_gpr  := $(xsd_dir)/gnat2xml.gpr
xsd_main := gnat2xml-gnat2xsd
xsd_exe  := LD_LIBRARY_PATH=lib-dynamic $(xsd_dir)/gnat2xsd

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_auto_build-indep: build-factory
	gprbuild $(xsd_gpr) $(xsd_main) -p $(BUILDER_OPTIONS) \
	  $(foreach v,ADAFLAGS LDFLAGS,"-X$(v)=$($(v))")
	$(xsd_exe)           > $(xsd_dir)/ada-schema.xsd
	$(xsd_exe) --compact > $(xsd_dir)/ada-schema.compact.xsd
endif
override_dh_auto_clean::
	gprclean $(xsd_gpr)
	rm -f $(xsd_dir)/ada-schema.xsd $(xsd_dir)/ada-schema.compact.xsd

######################################################################
.PHONY: override_dh_install
override_dh_install:
	dh_install --package=asis-programs $(foreach t,$(TOOLS),tools/$(t)/$(t)) usr/bin
	dh_install --remaining-packages

.PHONY: override_dh_installman
override_dh_installman:
	dh_installman --package=asis-programs $(foreach t,$(TOOLS),debian/man/$(t).1)
	dh_installman --remaining-packages

=== debian/watch ===
version=4

opts=\
  repack,\
  compression=xz,\
  filenamemangle=s/^.*download=// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/@PACKAGE@ \
.*@PACKAGE@-gpl@ANY_VERSION@-src@ARCHIVE_EXT@

## asis 2018

=== tools/gnat2xml/Makefile ===
--- 
+++ 
@@ -65,11 +65,16 @@
 	@# cd test ; xmllint --schema ../ada-schema.compact.xsd.new actual.compact/*.xml --noout
 	cd test ; xmllint --schema ../ada-schema.xsd.new actual.verbose/*.xml --noout
 
-	@# Compare schemas to expected versions.
+	@# Compare schemas to expected versions. Strip out the copyright notices before
+	@# doing the comparison, so if that's the only difference, we won't fail.
 	diff    ada-schema.xsd ada-schema.xsd.new | head -80
 	diff    ada-schema.compact.xsd ada-schema.compact.xsd.new | head -80
-	diff -q ada-schema.xsd ada-schema.xsd.new
-	diff -q ada-schema.compact.xsd ada-schema.compact.xsd.new
+	grep -v 'gnat2xsd Copyright (C) 2012-201., AdaCore, Inc\.' ada-schema.xsd.new > ada-schema.xsd.new.no-copyright
+	grep -v 'gnat2xsd Copyright (C) 2012-201., AdaCore, Inc\.' ada-schema.xsd > ada-schema.xsd.no-copyright
+	grep -v 'gnat2xsd Copyright (C) 2012-201., AdaCore, Inc\.' ada-schema.compact.xsd.new > ada-schema.compact.xsd.new.no-copyright
+	grep -v 'gnat2xsd Copyright (C) 2012-201., AdaCore, Inc\.' ada-schema.compact.xsd > ada-schema.compact.xsd.no-copyright
+	diff -q ada-schema.xsd.no-copyright ada-schema.xsd.new.no-copyright
+	diff -q ada-schema.compact.xsd.no-copyright ada-schema.compact.xsd.new.no-copyright
 
 XML2GNAT_SRCS=*.ad[sb] mckae/*.ad[sb] ../tool_utils/*.ad[sb]

=== debian/changelog ===
asis (2018-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:40 +0200

asis (2018-1) experimental; urgency=medium

  * New upstream release. No ALI/SO renaming in experimental.
  * Rebuild with changed but not renamed libgnatcoll closes: #902043.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 23 Jun 2018 17:24:07 +0200

asis (2017-3) experimental; urgency=medium

  * Rebuild with gnat-8 and updated gnatvsn, xmlada, gnatcoll.
    Rename shared library and -dev package per Debian Ada policy.
    gcc-7.diff is not needed anymore.
  * Remove watch file. Explain why in README.source.
  * Debhelper 11.
  * Standards-Version 4.1.4:
  * Drop obsolete version restriction on dpkg-dev.
  * Update upstream Homepage.
  * Remove white spaces in this changelog.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 08 May 2018 09:04:22 +0200

=== debian/control ===
--- 
+++ 
@@ -4,26 +4,26 @@
  Nicolas Boulenguez <nicolas@debian.org>
 Section: libdevel
 Priority: optional
-Standards-Version: 4.1.0
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
- gnat, gnat-7,
+Standards-Version: 4.1.4
+Build-Depends: debhelper (>= 11),
+ gnat, gnat-8,
 # This line is parsed by debian/rules.
- libgnatvsn7-dev (>= 7.1.0-10),
+ libgnatvsn8-dev,
 # gnatvsn providing rident.ads.
 # gprbuild cleaning auto.cgpr
  gprbuild (>= 2017),
 # Some tools require gnatcoll.
- libgnatcoll16.1.0-dev (>= 17.0.2017-3),
- libxmlada-input7-dev (>= 17.1.2017-5),
- libxmlada-sax7-dev (>= 17.1.2017-5),
- libxmlada-dom7-dev (>= 17.1.2017-5),
+ libgnatcoll17-dev,
+ libxmlada-input8-dev,
+ libxmlada-sax8-dev,
+ libxmlada-dom8-dev,
 # dh-ada-library knowing the new /usr/share/gpr path to projects.
  dh-ada-library (>= 6.11)
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.asis
-Homepage: http://libre.adacore.com/libre/tools
+Homepage: https://www.adacore.com/community
 
-Package: libasis2017-dev
+Package: libasis2018-dev
 Architecture: any
 Depends: ${ada:Depends}, ${misc:Depends}
 Suggests: asis-doc
@@ -37,8 +37,8 @@
 Package: asis-programs
 Architecture: any
 Section: devel
-Depends: gnat, gnat-7, ${shlibs:Depends}, ${misc:Depends}
-Recommends: libaunit17.2017-dev
+Depends: gnat, gnat-8, ${shlibs:Depends}, ${misc:Depends}
+Recommends: libaunit18-dev
 Description: Ada Semantic Interface Specification (ASIS) example programs
  ASIS (Ada Semantic Interface Specification) lets you develop applications
  to walk through the sources of your Ada programs and examine the semantic
@@ -55,12 +55,12 @@
   * gnattest creates AUnit test skeletons and harness for a project
     (gnattest requires the libaunit development package to be installed)
 
-Package: libasis2017
+Package: libasis2018
 Architecture: any
 Section: libs
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: gnat, gnat-7, ${shlibs:Depends}, ${misc:Depends}
+Depends: gnat, gnat-8, ${shlibs:Depends}, ${misc:Depends}
 Description: Ada Semantic Interface Specification (ASIS) runtime library
  ASIS (Ada Semantic Interface Specification) lets you develop applications
  to walk through the sources of your Ada programs and examine the semantic

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #! /usr/bin/make -rf
 # Debian build script for asis
 # Copyright (c) 2003-2014 Ludovic Brenta <lbrenta@debian.org>
-# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2018 Nicolas Boulenguez <nicolas@debian.org>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under terms of the GNU General Public License as published

=== debian/tests/control ===
Tests: link-with-shared parse-source
Depends: @, gprbuild

## asis 2019

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 # ==================================================== install
 
 .PHONY: install-clean
-install-clean:
+install-clean-legacy:
 ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/asislib))
 	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
 		--project-subdir=lib/gnat asislib
@@ -81,25 +81,38 @@
 		--project-subdir=lib/gnat build_asis
 endif
 
+install-clean: install-clean-legacy
+ifneq (,$(wildcard $(prefix)/share/gpr/manifests/asislib))
+	-$(GPRINSTALL) --uninstall --prefix=$(prefix) asislib
+endif
+ifneq (,$(wildcard $(prefix)/share/gpr/manifests/build_asis))
+	-$(GPRINSTALL) --uninstall --prefix=$(prefix) build_asis
+endif
+
+GPRINST_OPTS=-p -f --prefix=$(prefix) --sources-subdir=include/asis \
+	--lib-subdir=lib/asis -XBLD=$(BLD) -XOPSYS=$(OPSYS) \
+	--build-var=LIBRARY_TYPE --build-var=ASIS_BUILD --build-name=static
+
 .PHONY: install
 install: install-clean
-	$(GPRINSTALL) -p -f --prefix=$(prefix) --sources-subdir=include/asis \
-		--lib-subdir=lib/asis --project-subdir=lib/gnat -XBLD=$(BLD) \
-		-XOPSYS=$(OPSYS) -XASIS_COMPONENTS=lib build_asis.gpr
+	$(GPRINSTALL) $(GPRINST_OPTS) -XASIS_COMPONENTS=lib build_asis.gpr
 
 .PHONY: install-tools-clean
-install-tools-clean:
+install-tools-clean-legacy:
 ifneq (,$(wildcard $(prefix)/lib/gnat/manifests/asistools))
 	-$(GPRINSTALL) --uninstall --prefix=$(prefix) \
 		--project-subdir=lib/gnat asistools
 endif
 
+install-tools-clean:
+ifneq (,$(wildcard $(prefix)/share/gpr/manifests/asistools))
+	-$(GPRINSTALL) --uninstall --prefix=$(prefix) asistools
+endif
+
 .PHONY: install-tools
 install-tools: install-tools-clean
-	$(GPRINSTALL) -p -f --prefix=$(prefix) --sources-subdir=include/asis \
-		--lib-subdir=lib/asis --project-subdir=lib/gnat -XBLD=$(BLD) \
-		--install-name=asistools \
-		-XOPSYS=$(OPSYS) -XASIS_COMPONENTS=tools build_asis.gpr
+	$(GPRINSTALL) $(GPRINST_OPTS) --no-project \
+		--install-name=asistools -XASIS_COMPONENTS=tools build_asis.gpr
 
 # ==================================================== test

=== debian/changelog ===
asis (2019-5) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.
  * Standards-Version: 4.5.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Dec 2020 16:17:53 +0100

asis (2019-4) experimental; urgency=medium

  * Restrict versions of build dependencies, fixing the build of indirect
    reverse dependencies in experimental where ALI versions do not change.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 16 Nov 2020 15:28:26 +0000

asis (2019-3) experimental; urgency=medium

  * Rebuild with gnat10. Rename lib and -dev accordingly.
  * Maintain 3 tool lists instead of generating code.
  * Debhelper 13.
  * Pass build flags via the environment
  * Move dh-ada-library to Build-Depends-Arch.
  * Deduplicate examples.
  * Tighten dependencies of autopkgtests.
  * Drop obsolete Pre-Depends.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 23 May 2020 08:43:50 +0000

asis (2019-2) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.
  * Update Xavier's address.
  * Use dh-sequence-* syntax for dh-ada-library
  * Standards-Version: 4.5.0.
  * Remove redundant branch selection from Vcs-Git field

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 17:55:12 +0100

asis (2019-1) experimental; urgency=medium

  * New upstream version built with gnat-9 and updated dependencies.
    Rename the lib and -dev packages accordingly.
  * Use packaged libxmlezout instead of an old embedded copy.
  * Move VCS to salsa.debian.org.
  * Install asis-doc contents into /usr/share/doc/asis-programs.
  * Report more link warnings.
  * Debhelper: 12. Standards-Version: 4.4.1. Rules-Requires-Root: no.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 29 Oct 2019 14:36:44 +0100

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,31 @@
 Source: asis
 Maintainer: Ludovic Brenta <lbrenta@debian.org>
-Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
+Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
 Section: libdevel
 Priority: optional
-Standards-Version: 4.1.4
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
+Standards-Version: 4.5.1
+Build-Depends:
+ debhelper-compat (= 13),
+ gnat, gnat-10,
 # This line is parsed by debian/rules.
- libgnatvsn8-dev,
-# gnatvsn providing rident.ads.
-# gprbuild cleaning auto.cgpr
- gprbuild (>= 2017),
-# Some tools require gnatcoll.
- libgnatcoll17-dev,
- libxmlada-input8-dev,
- libxmlada-sax8-dev,
- libxmlada-dom8-dev,
-# dh-ada-library knowing the new /usr/share/gpr path to projects.
- dh-ada-library (>= 6.11)
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.asis
+ gprbuild (>= 2021.0.0.0778b109-2),
+ libgnat-util10-dev,
+ libgnatcoll19-dev (>= 21.0.0-2),
+ libxmlada-dom10-dev (>= 21.0.0),
+ libxmlada-input10-dev (>= 21.0.0),
+ libxmlada-sax10-dev (>= 21.0.0),
+ libxmlezout8-dev,
+Build-Depends-Arch:
+ dh-ada-library (>= 7.2),
+ dh-sequence-ada-library,
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/asis
+Vcs-Git: https://salsa.debian.org/debian/asis.git
 Homepage: https://www.adacore.com/community
 
-Package: libasis2018-dev
+Package: libasis2019.1-dev
+# This line is parsed by debian/rules.
 Architecture: any
 Depends: ${ada:Depends}, ${misc:Depends}
 Suggests: asis-doc
@@ -37,8 +39,8 @@
 Package: asis-programs
 Architecture: any
 Section: devel
-Depends: gnat, gnat-8, ${shlibs:Depends}, ${misc:Depends}
-Recommends: libaunit18-dev
+Depends: gnat, gnat-10, ${shlibs:Depends}, ${misc:Depends}
+Recommends: libaunit20-dev
 Description: Ada Semantic Interface Specification (ASIS) example programs
  ASIS (Ada Semantic Interface Specification) lets you develop applications
  to walk through the sources of your Ada programs and examine the semantic
@@ -55,12 +57,11 @@
   * gnattest creates AUnit test skeletons and harness for a project
     (gnattest requires the libaunit development package to be installed)
 
-Package: libasis2018
+Package: libasis2019.1
 Architecture: any
 Section: libs
 Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
-Depends: gnat, gnat-8, ${shlibs:Depends}, ${misc:Depends}
+Depends: gnat, gnat-10, ${shlibs:Depends}, ${misc:Depends}
 Description: Ada Semantic Interface Specification (ASIS) runtime library
  ASIS (Ada Semantic Interface Specification) lets you develop applications
  to walk through the sources of your Ada programs and examine the semantic

=== debian/rules ===
#! /usr/bin/make -rf
# Debian build script for asis
# Copyright (c) 2003-2014 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2020 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under terms of the GNU General Public License as published
# by the Free Software Foundation; either version 3, or (at your
# option) any later version. This build script is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY; without even
# the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details. You
# should have received a copy of the GNU General Public License
# distributed with this build script; see file
# /usr/share/common-licenses/GPL. If not, see <http://www.gnu.org/licenses/>.

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: libasis\([0-9.]\+\)$$/ \
    soversion:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_ADAFLAGS_MAINT_APPEND := -gnatfno -gnatwa -gnatVa
DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

BUILDER_OPTIONS := $(subst -j,-XPROCESSORS=,$(BUILDER_OPTIONS))

######################################################################
%:
	dh $@

# Ignore upstream Makefile/configure.
.PHONY: $(addprefix override_dh_auto_,configure build-arch build-indep test install clean)

######################################################################
# Build the dynamic library and tools.
# Upstream Makefile does not allow to select tool, skip a static assistant,
# or select gnat2xml mains.
# The aggregate project increases performance, as gprbuild only parses
# all projects once.
tools_gpr := debian/tools.gpr

override_dh_auto_build-arch:
	gprbuild $(tools_gpr) -p $(BUILDER_OPTIONS) -Xsoversion=$(soversion)
override_dh_auto_clean::
	gprclean $(tools_gpr) -Xsoversion=$(soversion)

######################################################################
# The factory generated sources are required for both -arch (for
# gnat2xml gnatpp) and -indep (for the schemas via gnat2xsd).
# The static ASIS library is built here as a dependency.
factory_dir := tools/tool_utils
factory_gpr := $(factory_dir)/generate_factory.gpr
factory_exe := $(factory_dir)/ada_trees-generate_factory
factory_out := ada_trees-factory

override_dh_auto_configure:
	gprbuild $(factory_gpr) -p $(BUILDER_OPTIONS)
	$(factory_exe)
	mv -f $(factory_out).nb $(factory_dir)/$(factory_out).adb
	mv -f $(factory_out).ns $(factory_dir)/$(factory_out).ads
override_dh_auto_clean::
	gprclean asis.gpr
	gprclean $(factory_gpr)
	rm -f $(factory_dir)/$(factory_out).ad[bs] $(factory_out).n[bs]

######################################################################
xsd_dir  := tools/gnat2xml
xsd_gpr  := $(xsd_dir)/gnat2xml.gpr
xsd_main := gnat2xml-gnat2xsd
xsd_exe  := LD_LIBRARY_PATH=lib-dynamic $(xsd_dir)/gnat2xsd

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_auto_build-indep:
	gprbuild $(xsd_gpr) $(xsd_main) -p $(BUILDER_OPTIONS)
	$(xsd_exe)           > $(xsd_dir)/ada-schema.xsd
	$(xsd_exe) --compact > $(xsd_dir)/ada-schema.compact.xsd
endif
override_dh_auto_clean::
	gprclean $(xsd_gpr)
	rm -f $(xsd_dir)/ada-schema.xsd $(xsd_dir)/ada-schema.compact.xsd

######################################################################
examples := debian/asis-doc/usr/share/doc/asis-doc/examples

.PHONY: override_dh_installexamples
override_dh_installexamples:
	dh_installexamples --package=asis-doc --doc-main-package=asis-programs
  # Replace duplicate files with relative symlinks, except during -arch builds.
	if test -d $(examples); then \
	  rdfind -makeresultsfile false -makesymlinks true $(examples) && \
	  symlinks -r -s -c $(examples); \
	fi
	dh_installexamples --remaining-packages

.PHONY: override_dh_installdocs
override_dh_installdocs:
	dh_installdocs --package=asis-doc --doc-main-package=asis-programs
	dh_installdocs --remaining-packages

=== debian/tests/control ===
Tests: parse-source

Tests: link-with-shared
Depends: @, gprbuild
